package fr.bhprod.sga.map.editor.swing;

import java.io.File;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import fr.bhprod.sga.map.editor.gl.MapCanvasImpl;
import fr.bhprod.sga.terrain.TerrainManager;

/**
 * 
 * @author jbeaufils
 * @version 1.0
 */

public class MapMenuAction {
	public static final Logger LOGGER = Logger.getLogger(MapMenuAction.class);

	public static void quit(JFrame frame) {
		int value = JOptionPane.showOptionDialog(frame, "Are you sure you want to quit ?", "Quit ?", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE, null, null, null);
		if (value == JOptionPane.YES_OPTION) {
			System.exit(0);
		}
	}
	
	public void saveMap(JFrame frame, File file, MapCanvasImpl impl) {
		LOGGER.debug(file);
		if (file.exists()) {
			int value = JOptionPane.showOptionDialog(frame, "Overwrite this file ?", "Warning", JOptionPane.YES_NO_OPTION, JOptionPane.PLAIN_MESSAGE, null, null, null);
			if (value == JOptionPane.NO_OPTION) {
				return;
			}
		}
		TerrainManager.save(file,impl.getTerrain());
	}
	
	public void loadMap(File file, MapCanvasImpl impl) {
		LOGGER.debug(file);

		impl.setLoadTerrain(file);
	}

	public void applyDetailTexture(File textureFile, String selectedPatch, MapCanvasImpl impl) {
		// If there is no texture selected, do nothing
		if (textureFile == null) {
			LOGGER.debug("No texture file selected");
			return;
		}
		
		// If there is no mesh selected, do nothing
		if (selectedPatch == null) {
			LOGGER.debug("No patch selected");
			return;
		}
		
		// If the texture file doens't exist, do nothing
		if (!textureFile.exists()) {
			LOGGER.error("The texture file ("+textureFile+") doesn't exist");
			return;
		}

		impl.applyDetailTexture(textureFile, selectedPatch);
	}

}

